/************************************************************************
 *			finger daemon user-configurable			*
 *		       (c) 1999-2001 Robert Trebula R0B0		*
 *		       http://www.elf.stuba.sk/~trebular		*
 ************************************************************************/
#define NAME_LEN 255
#define LINE 255
#define PLAN_LENGTH 50/*lines*/

//global
extern struct hostent *remote;
extern char *remuser;

//general
struct fstruct {
	char login[UT_NAMESIZE]; //login name
	char realname[LINE+1]; //real name
	char homedir[LINE+1]; //home directory
	char shell[LINE+1]; //shell
	struct ustruct *utmplist; //first item of the utmplist
	struct ustruct *last; //last item of the utmplist
	int loggedon; //number of connections
	int isuser; //=1 when user exists
	time_t llogged; //time of last login
	char lhost[UT_HOSTSIZE]; //place of last login
	time_t mailread; //time of last mail reading
	short int allwaysin;
	char plan[LINE+1]; //filename of .plan
	char pgpkey[LINE+1]; //filename of .pgpkey
};
typedef struct fstruct *DATA; 

struct ustruct {
	char tty[UT_LINESIZE];
	int pid;
	time_t since;
	time_t idle;
	char hostname[UT_HOSTSIZE];
	struct ustruct *next;
};

//big.c
int main(int argc,char **argv);
void show_user(char *name); //parses everything for `finger someone@somewhere`
void showup(DATA a); //shows the data for `finger someone@somewhere`
void read_utmp(DATA a,char *name); //parses /var/run/utmp
void show_stats(void); //shows the stuff for `finger @somewhere`
void read_pwent(DATA a,struct passwd *b); //parses /etc/passwd
void parse_wtmp(DATA a,char *name); //looks for the 'last logged time'
void check_remote(int fd); //checks remote machine
void initialize(DATA a); //sets the stuff to NULLs and 0s
int show_file(char *name); //writes a file to stdout
void dealloc_utmplist(DATA a); //deallocates utmplists after use
void alrmhndlr(int); //time-out signal handler


//small.c
char *line(FILE *f); //reads one line from file
void read_rcfile(DATA b,FILE *a); //parses the .fingerrc file
int getcommand (char *line); //gets a command from line read from .fingerrc
char *terminate(char *a); //terminates string coming over a netlink
FILE *getrc(char *home); //fopens user's .fingerrc by his home directory
char *count_time(time_t t); //formats a time argument
void noidle(DATA fs); //works around .noidle command in .fingerrc
time_t get_idle(char *tty); //counts idle time on given tty
time_t get_time_from_word(char *word); //parses user-given `last logged`
void from_host(DATA fs,char *hostname); //sets 'remote host' from rcfile
void stat_mailfolder(DATA a); //reads mail folder time stamp (last mail reading)
short int section_condition(char *line); //checks whether to use this section 
void show_version(void); //this function takes you to heaven

